/**
*
*/

import RTIcap.*;
import java.util.*;

/**
*/
public class InteractionNaming 
{
   Hashtable idToName = new Hashtable();
   Hashtable nameToId = new Hashtable();
   Hashtable idToRecord = new Hashtable();

   public
   InteractionNaming() { }

    /**
    */
    public
    short getInteractionClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       Short ret = (Short) nameToId.get(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return ret.shortValue();

    }// end of getInteractionClassHandle()

    /**
    */
    public
    String getInteractionClassName(short theHandle)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       String ret = (String) idToName.get(new Short(theHandle));

       if(ret==null) throw new RTIcap.InteractionClassNotDefined();

       return ret;

    }// end of getInteractionClassName()

    /**
    */
    public
    short getParameterHandle(String theName, short whichClass)
          throws RTIcap.InteractionClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       InteractionRecord rec = (InteractionRecord) idToRecord.get(new
Short(whichClass)); 
  
       if(rec==null) throw new RTIcap.InteractionClassNotDefined();

       return rec.getParameterHandle(theName);

    }// end of getParameterHandle()

    /**
    */
    public
    String getParameterName(short theHandle, short whichClass)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.InteractionParameterNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       InteractionRecord rec = (InteractionRecord) idToRecord.get(new Short(whichClass)); 
  
       if(rec==null) throw new RTIcap.InteractionClassNotDefined();

       return rec.getParameterName(theHandle);

    }// end of getParameterName()

}// end of class InteractionNaming

